@use 'sass:math';

@function map-deep-get($map, $keys...) {
  @each $key in $keys {
    $map: map-get($map, $key);
  }
  @return $map;
}

/**
 * @return clamp com o valor medio responsivo. Todoas as propriedade devem ter a mesma unidade.
 * $min-value: valor minimo do elemento
 * $max-value: valor maximo do elemento
 * $min-vw: largura minima, apartir da qual é aplicado o valor medio do clamp
 * $max-vw:largura maxima, onde será apresentado o $max-value:

 * ser inverter os valores de $min-vw e $max-vw, obtem o mesmo efeito mas ao contrario, do valor maior ao menor.
 */

@function fluid-type(
  $min-value,
  $max-value,
  $min-vw: $viewport--mobile-width,
  $max-vw: $viewport--desktop-width
) {
  // valida se todas os parametros possuem a unidade rem.
  $isRem: true;
  $schema: ($min-value, $max-value, $min-vw, $max-vw);

  @each $unit in $schema {
    @if math.unit($unit) != rem {
      $isRem: false;
      @error "`#{$unit}` it is not of the 'rem' type. All units must have the same unit type: rem";
    }
  }

  @if $isRem == false {
    @return -1;
  }

  // @return $min-value caso os valores de $min-value e $max-value forem iguais
  @if $min-value == $max-value {
    @return $min-value;
  }

  /** Calculate clamp´s medium value */
  $factor: math.div(1, ($max-vw - $min-vw)) * ($max-value - $min-value);
  $calc-value: unquote(
    '#{ $min-value - ($min-vw * $factor) } + #{ 100vw * $factor }'
  );

  @return clamp(
    #{if($min-value > $max-value, $max-value, $min-value)},
    #{$calc-value},
    #{if($min-value > $max-value, $min-value, $max-value)}
  );
}

/**
 * @return percentagem
 *
 * calcula percentagem de um valor minimo, em um viewport, que deverá aumentar gradualmente de forma responsiva.
 *
 * $min--value: valor minimo do padding/margin
 * $min--width: largura minima
 */

@function calcPercentage($min--value, $min--width: $rg-viewport--mobile-width) {
  $percentage: math.div($min--value * 100%, $min--width);
  @return $percentage;
}
